/***********************************************************************/
/*                                                                     */
/*  FILE        :testt.c                                               */
/*  DATE        :Thu, Aug 23, 2012                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :RX62T                                                 */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.53).    */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
                  
#include "iodefine.h"
#include "ics_rx62t_uart0.h"
#include <machine.h>
#include <math.h>
#include "iolib.h"
#include "testt.h"

// DTC̃e[uGAm(0x3000SectionmۂĂ) 
#pragma section DTCTABLE
unsigned long dtc_table[256]; // caution allignment 0x000
#pragma section


#define  LED1_set(d) (PORTA.DR.BIT.B2=(d))
#define  LED2_set(d) (PORTA.DR.BIT.B3=(d))
#define  LED3_set(d) (PORTB.DR.BIT.B0=(d))
#define  LED4_set(d) (PORTB.DR.BIT.B3=(d))

#define  SW_in()     (PORT9.DR.BIT.B1)


unsigned short an000, an001, an002, an003;
unsigned short an100, an101, an102, an103;

unsigned int   cnt = 0;

float   m = 0;
float   iu_ad;
float   refu, refv, refw;
float   offset = 0;
float   refi = 0;
float   refs = 2.0f;
float   Ra   = 1.1f;
float   bmf  = 0;
float   Vu   = 0.0;
float   Vv   = 0.0;
float   Vout_est = 0;
float   Vout_ad  = 0;


void main(void);


void H_Init(void)
{
    /********** NbN̐ݒ **********/
    SYSTEM.SCKCR.BIT.ICK = 0x00; // VXeNbN(ICLK)       EXTAL~8 (96MHz)
    SYSTEM.SCKCR.BIT.PCK = 0x01; // ӃW[NbN(PCLK) EXTAL~4 (48MHz)

    SYSTEM.MSTPCRA.BIT.MSTPA7  = 0; /*GPT   */
    SYSTEM.MSTPCRA.BIT.MSTPA16 = 0; /*S12AD0*/
    SYSTEM.MSTPCRA.BIT.MSTPA17 = 0; /*S12AD1*/
    SYSTEM.MSTPCRA.BIT.MSTPA23 = 0; /*AD    */
    SYSTEM.MSTPCRA.BIT.MSTPA24 = 0; /*S12AD */

    PORT9.DDR.BIT.B1 = 0; /*SW1  P91 */
    PORTA.DDR.BIT.B2 = 1; /*LED1 PA2 */
    PORTA.DDR.BIT.B3 = 1; /*LED2 PA3 */
    PORTB.DDR.BIT.B0 = 1; /*LED3 PB0 */
    PORTB.DDR.BIT.B3 = 1; /*LED4 PB3 */
   
    PORTB.DDR.BIT.B4 = 0; /*HW  PB4 */
    PORT1.DDR.BIT.B1 = 0; /*HV  P11 */
    PORT1.DDR.BIT.B0 = 0; /*HU  P10 */
    PORTA.DDR.BIT.B5 = 0; /*Z   PA5 */
    PORT3.DDR.BIT.B2 = 0; /*B   P32 */
    PORT3.DDR.BIT.B3 = 0; /*A   P33 */
   
    PORT7.DR.BYTE  = 0x00;                    /* PWM port */
    PORT7.DDR.BYTE = (PORT7.DDR.BYTE) | 0x7E; /* PWM port */

    /** 12bit ADC **/
    S12AD0.ADCSR.BYTE  = 0x2C;    /* single mode */
    S12AD0.ADANS.WORD  = 0x3303;  /* OPA_EN= AN000,AN001 */
    S12AD1.ADCSR.BYTE  = 0x2C;
    S12AD1.ADANS.WORD  = 0x3404;  /* OPA_EN= AN102       */
    
    S12AD0.ADPG.BIT.PG000GAIN = 9;  /* Gain = x5 */
    S12AD0.ADPG.BIT.PG001GAIN = 9;  /* Gain = x5 */
    S12AD1.ADPG.BIT.PG102GAIN = 9;  /* Gain = x5 */

    /********************* ߓdی **********************/
    S12AD.ADCMPMD0.BIT.CEN000 = 3;     /* window comp for Iu */
    S12AD.ADCMPMD0.BIT.CEN001 = 3;     /* window comp for Iw */
    S12AD.ADCMPMD0.BIT.CEN102 = 3;     /* window comp for Iv */

#if 1
    S12AD.ADCMPMD1.BIT.REFL   = 2;     /* 2/8 = -5A */
    S12AD.ADCMPMD1.BIT.REFH   = 6;     /* 6/8 =  5A */
#else
    S12AD.ADCMPMD1.BIT.REFL   = 3;     /* 3/8 = -2.5A */
    S12AD.ADCMPMD1.BIT.REFH   = 5;     /* 5/8 =  2.5A */
#endif
    S12AD.ADCMPMD1.BIT.CSEL0  = 1;     /* detect after opamp    */
    S12AD.ADCMPMD1.BIT.VSELH0 = 1;     /* Use REFH as reference */
    S12AD.ADCMPMD1.BIT.VSELL0 = 1;     /* Use REFL as reference */
    S12AD.ADCMPMD1.BIT.CSEL1  = 1;     /* detect after opamp    */
    S12AD.ADCMPMD1.BIT.VSELH1 = 1;     /* Use REFH as reference */
    S12AD.ADCMPMD1.BIT.VSELL1 = 1;     /* Use REFL as reference */

    S12AD.ADCMPNR0.BIT.C000NR = 8;     /* detect PCLK 16times   */
    S12AD.ADCMPNR0.BIT.C001NR = 8;
    S12AD.ADCMPNR1.BIT.C102NR = 8;

    S12AD.ADCMPFR.BYTE    = 0;     /* error clear */

    S12AD.ADCMPSEL.BIT.SEL000 = 1;
    S12AD.ADCMPSEL.BIT.SEL001 = 1;
    S12AD.ADCMPSEL.BIT.SEL102 = 1;
    S12AD.ADCMPSEL.BIT.IE     = 0;
    S12AD.ADCMPSEL.BIT.POERQ  = 1;     /* Enable POE */

    POE.POECR3.BIT.GPT0ABZE = 1;
    POE.POECR3.BIT.GPT1ABZE = 1;
    POE.POECR3.BIT.GPT2ABZE = 1;
    POE.POECR4.BIT.CMADDMT34ZE = 1;

    LED1_set(1);
    LED2_set(1);
    LED3_set(1);
    LED4_set(1);
}


void main(void)
{
    H_Init();

    ics_init((unsigned int)(&dtc_table), 6);

    inverter_init(10000, 3000, 3);

    inverter_start_int();
    GPT0.GTST.BIT.TCFPU = 0;

    while (1)
    {
        nop();
    }
}




void  int_carrier(void)
{
    int i;
    static int cnt = 0;

    ICU.IR[0x69].BIT.IR = 0;
    GPT0.GTST.BIT.TCFPU = 0;

    S12AD0.ADCSR.BIT.ADST = 1;
    S12AD1.ADCSR.BIT.ADST = 1;
 
    LED1_set(1);
   
    for(i=0;i<10;i++) { nop();}
    while (S12AD0.ADCSR.BIT.ADST==1) { nop(); }

    an000 = S12AD0.ADDR0A;   /* Iu  */
    an001 = S12AD0.ADDR1;    /* Iw  */
    an002 = S12AD0.ADDR2;    /* Vdc */
    an003 = S12AD0.ADDR3;    /* Vu  */
    an100 = S12AD1.ADDR0A;   /* Vv  */
    an101 = S12AD1.ADDR1;    /* Vw  */
    an102 = S12AD1.ADDR2;    /* Iv  */
    an103 = S12AD1.ADDR3;    /* VR1 */

    iu_ad = -((float)(an000 - 2048 + offset))/200.0f;
    //Vout_est = 24.0 * m;
    //Vu_est =   10.57 * m + 12.66;
    //Vv_est = - 10.57 * m + 12.66;
    Vout_est = 21.14 * m;
    Vu       = an003 / 4096.0 * 55.0;
    Vv       = an100 / 4096.0 * 55.0;
    Vout_ad  = Vu - Vv;

    
#if 1   /* d萧̏ꍇ  Jn */

	/* R[h͂Ȃ@@@@@@ */
	/* ϒm̏l 0@@@*/
        /* ϒmICSݒ肷 */

#endif  /* d萧̏ꍇ@I */

    
#if 0    /* d萧̏ꍇ  Jn */

    if (iu_ad>refi) { m = m - 0.0001;  }
    else            { m = m + 0.0001;  }

#endif   /* d萧̏ꍇ@I */


#if 0    /* tNd͈萧̏ꍇ@Jn */

    bmf = (Vout_est) - Ra * iu_ad;
    if (bmf>refs)   { m = m - 0.0001; }
    else            { m = m + 0.0001; }

#endif   /* tNd͈萧̏ꍇ@I */

    /*********** dvFϒ̐ *****************/
    /* ̐ȂƁA傫ȓd[^ɂ */
    if (m>0.25)     { m = 0.25;     }
    else if (m<0.0) { m = 0.0;      }
    else            { /* no code */ }

    refu =  m;
    refv = -m;
    refw =  0;

    inverter_set_uvw( refu, refv, refw );

    cnt++;
    if (cnt>=3)
    {
        ics_watchpoint();
        cnt = 0;
    }

    LED1_set(0);
}




